import os
os.system('pip3 install numpy')
import numpy as np

class Perceptron():
    
    def __init__(self):
        np.random.seed(1)
        self.weights = 2 * np.random.random((12, 1)) - 1

    def sigmoid(self, x):
        return 1 / (1 + np.exp(-x))

    def sigmoid_derivative(self, x):
        return x * (1 - x)

    def train(self, experiences):

        trainIn = []

        file = open("traininginput.txt", "r")
        while True:
            floatList = []
            trainingInput = file.readline()
            if not trainingInput:
                break;
            trainingInput = trainingInput.replace("[","")
            trainingInput = trainingInput.replace("]","")
            trainingInput = trainingInput.replace("'","")
            trainingInput = trainingInput.replace("\n","")
            nums = trainingInput.split(", ")
            for item in nums:
                item = float(item)
                floatList.append(item)
            trainIn.append(floatList)
        trainInFormatted = np.array(trainIn)
        file.close()

        trainOut = []

        file = open("trainingoutput.txt", "r")
        while True:
            floatList = []
            trainingOutput = file.readline()
            if not trainingOutput:
                break
            num = float(trainingOutput)
            floatList.append(num)
            trainOut.append(floatList)
        trainOutFormatted = np.array(trainOut)
        np.transpose(trainOutFormatted)
        file.close()

        print(".")
        print(".")
        print(".")
        print("Exposing neuron to your past experiences.")
        
        for experience in range(experiences):
            output = self.think(trainInFormatted)
            error = trainOutFormatted - output
            adjustments = np.dot(trainInFormatted.T, error * self.sigmoid_derivative(output))
            self.weights += adjustments

    def think(self, inputs):
        inputs = inputs.astype(float)
        output = self.sigmoid(np.dot(inputs, self.weights))
        return output

    def readMode(self):
        file = open("mode.txt", "r")
        mode = file.readlines();
        file.close()
        return mode

    def askFactorsForTraining(self):
        print("For the questions below,")
        print("type 0 for NO or 1 for YES.")
        print("")
        print("")
        A = str(input("Did you eat any eggs today? "))
        B = str(input("Did you eat meat today? "))
        C = str(input("Did you eat fruit today? "))
        D = str(input("Did you eat dairy today? "))
        E = str(input("Did you eat vegetables today? "))
        F = str(input("Did you eat dough today? "))
        G = str(input("Did you eat dessert food today? "))
        H = str(input("Did you eat or drink any protein supplements today? "))
        I = str(input("Did you snack today? "))
        J = str(input("Did you eat 2 or more filling (satisfying) meals today? "))
        K = str(input("Did you rigorously exercise today? "))
        L = str(input("Were you away from home for most of the day? "))

        userInputs = [A, B, C, D, E, F, G, H, I, J, K, L]

        file = open("traininginput.txt", "a")
        file.write(str(userInputs))
        file.write("\n")
        file.close()

        file = open("mode.txt", "w+")
        file.write(str("o"))
        file.close()
        print("")
        print("")
        print("")
        print("Be sure to note your weight every morning for comparison!")
        print("Please come back tomorrow to record your weight change outcome.")
        print("")
        print("")
        print("")
        print("")
        print("")
        print("")

    def askOutcomes(self):
        print("")
        print("")
        print("")

        outcome = 0

        print("")
        print("")
        print("")
        print("For the question below,")
        print("type 0 for LESS or 1 for MORE.")
        print("")
        print("")
        weightChangeOutcome = str(input("Do you weigh more or less than you did yesterday?"))

        file = open("trainingoutput.txt", "a")
        file.write(str(weightChangeOutcome))
        file.write("\n")
        file.close()

        file = open("mode.txt", "w+")
        file.write(str("f"))
        file.close()

        print("")
        print("")
        print("")
        print("Thank you for your submission!")
        print("Nobody has access to your submitted data except for you.")
        print("")
        print("")
        print("")

    def askFactorsForPrediction(self):
        print(".")
        print(".")
        print(".")
        print("The 12 questions you answered have been")
        print("prioritized by their impact on you.")
        print("_______________________________________")
        print("")
        print("")
        print("")
        print("Answer the 12 questions again, but this time")
        print("for a prediction of your body weight fluctuation")
        print("and insights about what's affecting it!")
        print("")
        print("")
        print("For the questions below,")
        print("type 0 for NO or 1 for YES.")
        print("")
        print("")
        A = str(input("Did you eat any eggs today? "))
        B = str(input("Did you eat meat today? "))
        C = str(input("Did you eat fruit today? "))
        D = str(input("Did you eat dairy today? "))
        E = str(input("Did you eat vegetables today? "))
        F = str(input("Did you eat dough today? "))
        G = str(input("Did you eat dessert food today? "))
        H = str(input("Did you eat or drink any protein supplements today? "))
        I = str(input("Did you snack today? "))
        J = str(input("Did you eat 2 or more filling meals today? "))
        K = str(input("Did you rigorously exercise today? "))
        L = str(input("Were you away from home for most of the day? "))

        userInputs = [A, B, C, D, E, F, G, H, I, J, K, L]

        print("....................................................")
        print("....................................................")
        print("....................................................")
        print("..                                                ..")
        print(".. YOUR PREDICTION & INSIGHTS SECTION BEGINS HERE ..")
        print("..                                                ..")
        print("....................................................")
        print("....................................................")
        print("....................................................")
        print(".")
        print(".")
        print(".")
        print("")
        print("Today's Experience Sequence: ")
        print(A, B, C, D, E, F, G, H, I, J, K, L)
        print("")
        print("")
        print("")
        prediction = analysis.think(np.array([A, B, C, D, E, F, G, H, I, J, K, L]))
        predictionFormatted = float(prediction[0])
        print("Body Weight Change Measurement:")
        print(predictionFormatted)
        print("")
        print("Body Weight Change Prediction: ")
        verdictNum = int(round(predictionFormatted))
        verdict = ""
        if verdictNum==0:
            verdict="Tomorrow morning you will weigh LESS than this morning."
        if verdictNum==1:
            verdict="Tomorrow morning you will weigh MORE than this morning."
        print(verdict)
        print("")
        factors = []
        eggs = "EGGS"
        factors.append(eggs)
        meat = "MEAT"
        factors.append(meat)
        fruit = "FRUIT"
        factors.append(fruit)
        dairy = "DAIRY"
        factors.append(dairy)
        veggies = "VEGGIES"
        factors.append(veggies)
        dough = "DOUGH"
        factors.append(dough)
        dessert = "DESSERT"
        factors.append(dessert)
        supplement = "SUPPLEMENTS"
        factors.append(supplement)
        snack = "SNACKING"
        factors.append(snack)
        meals = "MEALS"
        factors.append(meals)
        exercise = "EXERCISE"
        factors.append(exercise)
        home = "AWAY FROM HOME"
        factors.append(home)
        index = 0

        print("Ranking of Factors by Impact:")
        print("")
        factorsRanked = []
        weightsCopy = self.weights.copy()
        for index, weightCopy in enumerate(weightsCopy):
            if weightCopy < 0:
                weightsCopy[index] = weightsCopy[index] * -1
        weightsCopy = sorted(weightsCopy)
        for weightCopy in weightsCopy:
            for index, weight in enumerate(self.weights):
                if weightCopy == weight or weightCopy == weight * -1:
                    print(factors[index])
                    factorsRanked.append(factors[index])
        print("")
        print("Directional Pull of Factors:")
        print("")
        index = 0
        for weight in self.weights:
            if weight < 0:
                direction = " wants you to weigh LESS."
            elif weight == 0:
                direction = " is acting NEUTRAL."
            else:
                direction = " wants you to weigh MORE."
            print(factors[index] + direction)
            index += 1
        print("")
        print("Summary:")
        print("")
        print(factorsRanked[0] + " has a big impact on your weight fluctuation.")
        if self.weights[0] < 0:
            direction = "DOWN"
        elif self.weights[0] == 0:
            direction = "STABLE"
        else:
            direction = "UP"
        if self.weights[1] < 0:
            directionTwo = "DOWN"
        elif self.weights[1] == 0:
            directionTwo = "STABLE"
        else:
            directionTwo = "UP"
        if self.weights[2] < 0:
            directionThree = "DOWN"
        elif self.weights[2] == 0:
            directionThree = "STABLE"
        else:
            directionThree = "UP"  
        print(factorsRanked[0] + " is making your body weight go " + direction + ".")
        print(factorsRanked[1] + " and " + factorsRanked[2] + " impact you a considerable amount.")
        print(factorsRanked[1] + " brings your body weight " + directionTwo + ".")
        print(factorsRanked[2] + " brings your body weight " + directionThree + ".")
        print(factorsRanked[10] + " and " + factorsRanked[11] + " don't seem to affect your weight significantly.")
        if self.weights[10] < 0:
            directionFour = "DOWN"
        elif self.weights[10] == 0:
            directionFour = "STABLE"
        else:
            directionFour = "UP"
        if self.weights[11] < 0:
            directionFive = "DOWN"
        elif self.weights[11] == 0:
            directionFive = "STABILITY"
        else:
            directionFive = "UP"
        if directionFour == directionFive:
            print("It may be helpful for you to know that " + factorsRanked[10] + " and " + factorsRanked[11] + " both bring your weight " + directionFour + ".")
        print("It's worth considering how all of those factors take form in your life.")
        print("Impactful factors could be good or bad, depending on your goals.")
        print("The least impactful factors could be utilized for convenience.")
        print("The best additional question: Are " + factorsRanked[0] + " and " + factorsRanked[1] + " and " + factorsRanked[2] + " directly affecting your weight,")
        print("or are they usually present in your life when you're doing something else very impactful to your weight?")
        print("")
        print("")
        file = open("trainingoutput.txt", "r")
        lines = file.readlines()
        numLines = len(lines)
        numDays = numLines * 2
        print("My name is Barbelo and I'm in your computer.")
        print("I lived " + str(numDays) + " days of your life...9,000 times.")
        print("")
        print("To increase the number of days lived, submit more data.")
        print("")
        print("")
        print("")
        print("")

if __name__ == "__main__":

    analysis = Perceptron()
    print(".")
    print(".")
    print(".")
    print("Neuron's dendrites activated.")
    print("_______________________________________")

    print("//////////////////////////////////////////////")
    print("///                                        ///")
    print("///               SCALETRON                ///")
    print("///       Body Weight Change Predictor     ///")
    print("///         with Behavior-Based AI         ///")
    print("///                                        ///")
    print("///                                        ///")
    print("///   Questionnaires and full exact code   ///")
    print("///    Copyright © 2022 Wyatt Naftulin     ///")
    print("//////////////////////////////////////////////")
    print("")
    print("")
    print("Scaletron provides 2 easy questionnaires. One is about your life today,")
    print("and the other records whether your weight went up or down the next day (preferably in the morning).")
    print("By weighing these factors and outcomes in your life, Scaletron's artificial intelligence (AI)")
    print("can make predictions about your body weight fluctuation. It also gives you insights about what is tipping")
    print("the scale and in which direction. This AI is named Barbelo.")
    print("")
    print("")
    submitOrPredict = str(input("Type 0 to submit data or 1 for a prediction: "))
    print("")
    print("")
    print("")

    if submitOrPredict=="0":
        mode = analysis.readMode()
        if "f" in mode:
            analysis.askFactorsForTraining()
        else:
            analysis.askOutcomes()
    if submitOrPredict=="1":
        mode = analysis.readMode()
        if "f" in mode:
            analysis.train(9000)
            analysis.askFactorsForPrediction()
        else:
            print("A PREDICTION CANNOT BE MADE IF YOU ARE IN THE MIDDLE") 
            print("OF A 2-DAY CYCLE. YOU MUST SUBMIT AN OUTCOME (DAY 2)")
            print("FOR THE PREVIOUS DAY'S QUESTIONS (DAY 1) BEFORE")
            print("REQUESTING A PREDICTION FOR A NEW DAY 1 QUESTIONNAIRE.")
            print("PLEASE RESTART PROGRAM AND TYPE 0 INSTEAD.")
